SystemOrganization addCategory: #'Orange-Relay'!

ALAuthenticationRelay subclass: #ORAuthenticationRelay2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Relay'!

!ORAuthenticationRelay2 methodsFor: 'as yet unclassified' stamp: 'chc 2/27/2015 14:11'!
validate: aRequest against: aStipulation
	| request result authstring aLocator |
	(aRequest authorization isNil)
		ifTrue: [^self respondWithChallenge]
		ifFalse: [
	authstring := (aRequest authorization copyAfter: Character space) base64Decoded.
	request := ALAuthenticationRequest withUsername:  (authstring copyUpTo: $:)   password: (authstring copyAfter: $:).
	result := request signal].
	^(result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [ self denied ]
			! !

ALRelay subclass: #ORAuthenticationRelay
	instanceVariableNames: 'authenticator shunt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Relay'!

!ORAuthenticationRelay class methodsFor: 'instance creation' stamp: 'chc 6/16/2015 12:05'!
destination: aRelay authenticator: anAuthenticator shunt: aBlock
	^ self basicNew 
		initializeWithDestination: aRelay
		authenticator: anAuthenticator
		shunt: aBlock! !

!ORAuthenticationRelay methodsFor: 'authenticating' stamp: 'chc 6/16/2015 12:05'!
handleAuthRequest: aNotification
	| result |
	result := authenticator 
		authenticate: aNotification username 
		password: aNotification password.
	aNotification resume: result! !

!ORAuthenticationRelay methodsFor: 'authenticating' stamp: 'chc 6/16/2015 12:05'!
handleDeauthRequest: aNotification
	authenticator deauthenticate: aNotification user.
	aNotification resume! !

!ORAuthenticationRelay methodsFor: 'relaying' stamp: 'chc 6/16/2015 12:05'!
handleRequest: aRequest
	^ [destination handleRequest: aRequest]
		on: ALUserStipulation, ALAuthenticationRequest, ALDeauthenticationRequest
		do: [:notification |
			notification class caseOf:
				{[ALUserStipulation] -> [self validate: aRequest against: notification].
				[ALAuthenticationRequest] -> [self handleAuthRequest: notification].
				[ALDeauthenticationRequest] -> [self handleDeauthRequest: notification]}]
			
			! !

!ORAuthenticationRelay methodsFor: 'initialize-release' stamp: 'chc 6/16/2015 12:05'!
initializeWithDestination: aRelay authenticator: anAuthenticator shunt: aBlock
	self initializeWithDestination: aRelay.
	authenticator := anAuthenticator.
	shunt := aBlock! !

!ORAuthenticationRelay methodsFor: 'authenticating' stamp: 'chc 6/16/2015 12:05'!
validate: aRequest against: aStipulation
	| cookie doShunt user |
	doShunt := [^ shunt value: aRequest].
	user := aStipulation component user.
	user isNil ifTrue: doShunt.
	aRequest hasCookie ifFalse: doShunt.
	cookie := aRequest cookie 
		detect: [:ea | ea name = 'auth'] 
		ifNone: doShunt.
	(authenticator isToken: cookie value validFor: user)
		ifTrue: [aStipulation resume]
		ifFalse: doShunt! !
